; ##############################################################################
; ##############################################################################
; ##############################################################################
LCD_ANZEIGE_BEGRUESSUNG:
	; ZEILE1	
	;call LCD_CLEAR
	call LCD_ZEILE1
	ldi ZH, high(TEXT_LCD_BEGRUESSUNG_1*2)	; TEXT 
	ldi ZL,  low(TEXT_LCD_BEGRUESSUNG_1*2)
	call LCD_ANZEIGE_TEXT_Z
	; ZEILE2	
	call LCD_ZEILE2
	ldi ZH, high(TEXT_LCD_BEGRUESSUNG_2*2)	; TEXT 
	ldi ZL,  low(TEXT_LCD_BEGRUESSUNG_2*2)
	call LCD_ANZEIGE_TEXT_Z
	; ZEILE3		
	call LCD_ZEILE3
	ldi ZH, high(TEXT_LCD_BEGRUESSUNG_3*2)	; TEXT 
	ldi ZL,  low(TEXT_LCD_BEGRUESSUNG_3*2)
	call LCD_ANZEIGE_TEXT_Z
	; ZEILE4		
	call LCD_ZEILE4
	ldi ZH, high(TEXT_LCD_BEGRUESSUNG_4*2)	; TEXT 
	ldi ZL,  low(TEXT_LCD_BEGRUESSUNG_4*2)
	call LCD_ANZEIGE_TEXT_Z
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
LCD_ANZEIGE_ZEIT:
	LDS temp1,(adr_hh)
	call LCD_ZAHL2_TEMP1
	call LCD_DOPPEL_PUNKT

	LDS temp1,(adr_mm)
	call LCD_ZAHL2_TEMP1
	call LCD_DOPPEL_PUNKT


	LDS temp1,(adr_ss)
	jmp LCD_ZAHL2_TEMP1
; ##############################################################################
; ##############################################################################
; ##############################################################################
LCD_ANZEIGE_SECTOR:
	call SECTOR_NACH_TEMP1_4
	jmp LCD_ZAHL_TEMP1_2_3_4
; ##############################################################################
; ##############################################################################
; ##############################################################################
LCD_ANZEIGE_OK:
	call LCD_CLEAR
	call LCD_O
	call LCD_K
	jmp WAIT_200ms
; ##############################################################################
; ##############################################################################
; ##############################################################################
LCD_ANZEIGE_IDE_REGISTER_STATUS:
	LDS temp,(adr_IDE_REGISTER_STATUS)
	sbrc temp,7
	call LCD_TEXT_7_BSY 	
;-------------------------------------------------------------------------------
	LDS temp,(adr_IDE_REGISTER_STATUS)
	sbrc temp,6
	call LCD_TEXT_6_DRDY 	
;-------------------------------------------------------------------------------
	LDS temp,(adr_IDE_REGISTER_STATUS)
	sbrc temp,5
	call LCD_TEXT_5_DF 		
;-------------------------------------------------------------------------------
	LDS temp,(adr_IDE_REGISTER_STATUS)
	sbrc temp,4
	call LCD_TEXT_4_DSC 	
;-------------------------------------------------------------------------------
	LDS temp,(adr_IDE_REGISTER_STATUS)
	sbrc temp,3
	call LCD_TEXT_3_DRQ 	
;-------------------------------------------------------------------------------
	LDS temp,(adr_IDE_REGISTER_STATUS)
	sbrc temp,2
	call LCD_TEXT_2_COR 	
;-------------------------------------------------------------------------------
	LDS temp,(adr_IDE_REGISTER_STATUS)
	sbrc temp,1
	call LCD_TEXT_1_IDX 	
;-------------------------------------------------------------------------------
	LDS temp,(adr_IDE_REGISTER_STATUS)
	sbrc temp,0
	call LCD_TEXT_0_ERR
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
LCD_ANZEIGE_IDE_REGISTER_ERROR:
	LDS temp,(adr_IDE_REGISTER_ERROR_LAST)
	sbrc temp,7
	call LCD_TEXT_7_CRC 	
;-------------------------------------------------------------------------------
	LDS temp,(adr_IDE_REGISTER_ERROR_LAST)
	sbrc temp,6
	call LCD_TEXT_6_UNC 	
;-------------------------------------------------------------------------------
	LDS temp,(adr_IDE_REGISTER_ERROR_LAST)
	sbrc temp,5
	call LCD_TEXT_5_0 		
;-------------------------------------------------------------------------------
	LDS temp,(adr_IDE_REGISTER_ERROR_LAST)
	sbrc temp,4
	call LCD_TEXT_4_IDNF 	
;-------------------------------------------------------------------------------
	LDS temp,(adr_IDE_REGISTER_ERROR_LAST)
	sbrc temp,3
	call LCD_TEXT_3_0 		
;-------------------------------------------------------------------------------
	LDS temp,(adr_IDE_REGISTER_ERROR_LAST)
	sbrc temp,2
	call LCD_TEXT_2_ABRT 	
;-------------------------------------------------------------------------------
	LDS temp,(adr_IDE_REGISTER_ERROR_LAST)
	sbrc temp,1
	call LCD_TEXT_1_TK0NF 	
;-------------------------------------------------------------------------------
	LDS temp,(adr_IDE_REGISTER_ERROR_LAST)
	sbrc temp,0
	call LCD_TEXT_0_AMNF
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################



