; ##############################################################################
; ##############################################################################
; ##############################################################################
RS232_INITIALISIERUNG:
	sbi (RS232_DDR) ,(RS232_PIN_NR)	; auf AUSGANG	
	cbi (RS232_PORT),(RS232_PIN_NR)	; LOW			
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Bitrate: 	56.000		
; Frequenz: 28.000 Hz	
; Takte:	   385		
RS232_WAIT:
	WDR
	push temp
	ldi temp,0x79
;-------------------------------------------------------------------------------
RS232_WAIT_s:
	dec temp
	brne RS232_WAIT_s
;-------------------------------------------------------------------------------
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	pop temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
RS232_TX_TEMP1:
; Bit-Start									
	sbi (RS232_PORT),(RS232_PIN_NR)	; Bit clear	
	rcall RS232_WAIT
;-------------------------------------------------------------------------------
; Bit-0										
	sbrc temp1,(0)					; Skip if Bit...
	cbi (RS232_PORT),(RS232_PIN_NR)	; Bit set		
	sbrs temp1,(0)					; Skip if Bit...
	sbi (RS232_PORT),(RS232_PIN_NR)	; Bit clear		
	rcall RS232_WAIT
; Bit-1										
	sbrc temp1,(1)
	cbi (RS232_PORT),(RS232_PIN_NR)	; Bit set		
	sbrs temp1,(1)
	sbi (RS232_PORT),(RS232_PIN_NR)	; Bit clear		
	rcall RS232_WAIT
; Bit-2										
	sbrc temp1,(2)
	cbi (RS232_PORT),(RS232_PIN_NR)	; Bit set		
	sbrs temp1,(2)
	sbi (RS232_PORT),(RS232_PIN_NR)	; Bit clear		
	rcall RS232_WAIT
; Bit-3										
	sbrc temp1,(3)
	cbi (RS232_PORT),(RS232_PIN_NR)	; Bit set		
	sbrs temp1,(3)
	sbi (RS232_PORT),(RS232_PIN_NR)	; Bit clear		
	rcall RS232_WAIT
; Bit-4										
	sbrc temp1,(4)
	cbi (RS232_PORT),(RS232_PIN_NR)	; Bit set		
	sbrs temp1,(4)
	sbi (RS232_PORT),(RS232_PIN_NR)	; Bit clear		
	rcall RS232_WAIT
; Bit-5										
	sbrc temp1,(5)
	cbi (RS232_PORT),(RS232_PIN_NR)	; Bit set		
	sbrs temp1,(5)
	sbi (RS232_PORT),(RS232_PIN_NR)	; Bit clear		
	rcall RS232_WAIT
; Bit-6										
	sbrc temp1,(6)
	cbi (RS232_PORT),(RS232_PIN_NR)	; Bit set		
	sbrs temp1,(6)
	sbi (RS232_PORT),(RS232_PIN_NR)	; Bit clear		
	rcall RS232_WAIT
; Bit-7										
	sbrc temp1,(7)
	cbi (RS232_PORT),(RS232_PIN_NR)	; Bit set		
	sbrs temp1,(7)
	sbi (RS232_PORT),(RS232_PIN_NR)	; Bit clear		
	rcall RS232_WAIT
;-------------------------------------------------------------------------------
; Bit-PAUSE									
	cbi (RS232_PORT),(RS232_PIN_NR)	; Bit set	
	rcall RS232_WAIT
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; (*) (*) (*) (Sektor3) (Sektor2) (Sektor1) (Sektor0) (512Bytes) (PS)  = 520 Bytes
RS232_TX_DATA:
	; Vorhut				
	ldi temp1,'*'
	rcall RS232_TX_TEMP1	; TX	
	rcall RS232_TX_TEMP1	; TX	
	rcall RS232_TX_TEMP1	; TX	
;-------------------------------------------------------------------------------
	mov temp1,SECTOR3
	rcall RS232_TX_TEMP1	; TX	
	mov temp1,SECTOR2
	rcall RS232_TX_TEMP1	; TX	
	mov temp1,SECTOR1
	rcall RS232_TX_TEMP1	; TX	
	mov temp1,SECTOR0
	rcall RS232_TX_TEMP1	; TX	
;-------------------------------------------------------------------------------
	ldi ZL,LOW (adr_DATA)	; Z-DATA	
	ldi ZH,HIGH(adr_DATA)
	ldi YL,LOW (512)		; Schleife	
	ldi YH,HIGH(512)
;-------------------------------------------------------------------------------
RS232_TX_DATA_s:
	LD temp1,Z+
	rcall RS232_TX_TEMP1	; TX	
	sbiw YL,1				; -1	
	tst YL
	brne RS232_TX_DATA_s
	tst YH
	brne RS232_TX_DATA_s
;-------------------------------------------------------------------------------
	ldi temp1,'A'
	rcall RS232_TX_TEMP1	; TX	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
