; ##############################################################################
; ##############################################################################
; ##############################################################################
SD_INFO:
	call LCD_CLEAR
	call LCD_TEXT_SD
	call LCD_TEXT_INFO
	LDS temp,(adr_SD_SDHC_AKTIV)	
	tst temp
	breq SD_INFO_w
	call LCD_AUSRUFEZEICHEN
	call LCD_TEXT_SDHC
	call LCD_AUSRUFEZEICHEN
SD_INFO_w:
;-------------------------------------------------------------------------------
	rcall SD_STATUS_C				; read !	
	brcs SD_INFO_RUN
	call SD_CHECK
	ret
;-------------------------------------------------------------------------------
SD_INFO_RUN:
	call LCD_ZEILE3
	LDS temp1,(adr_SD_SECTOR_MAX0)
	LDS temp2,(adr_SD_SECTOR_MAX1)
	LDS temp3,(adr_SD_SECTOR_MAX2)
	LDS temp4,(adr_SD_SECTOR_MAX3)
	call LCD_ZAHL_TEMP1_2_3_4
	call LCD_S
	call LCD_e_
	call LCD_c_
;-------------------------------------------------------------------------------
	call LCD_ZEILE4
	rcall SD_CID_READ				; REGISTER CID	 (card identification)
	LDS temp,(adr_DATA+3)			; Produkt NAME
	call LCD_DATA_TEMP
	LDS temp,(adr_DATA+4)
	call LCD_DATA_TEMP
	LDS temp,(adr_DATA+5)
	call LCD_DATA_TEMP
	LDS temp,(adr_DATA+6)
	call LCD_DATA_TEMP
	LDS temp,(adr_DATA+7)
	call LCD_DATA_TEMP
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
SD_TEST_READ:
	call SD_CHECK
	call SECTOR_NULL
	call ZAHLER_NULL
	call UHR_NULL
;-------------------------------------------------------------------------------
SD_TEST_READ_s:
	call SD_SECTOR_READ		; read	
	call SECTOR_PLUS_EINS	; +1	
	call ZAHLER_PLUS_EINS
	LDS temp,(adr_ss)
	tst temp
	breq SD_TEST_READ_s
;-------------------------------------------------------------------------------
	call LCD_CLEAR
	call LCD_TEXT_SD
	call LCD_TEXT_READ
	call LCD_TEXT_TEST
	call LCD_ZEILE3
	call ZAHLER_ANZEIGE
	call LCD_TEXT_SEC_PRO_SEC
;-------------------------------------------------------------------------------
	call TASTATUR_ABFRAGE
	LDS temp,(adr_TASTE)
	tst temp
	breq SD_TEST_READ
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
SD_TEST_READ_ALLE:
.equ SDRA=0	; Startsector
	ldi temp1,BYTE1(SDRA)
	ldi temp2,BYTE2(SDRA)
	ldi temp3,BYTE3(SDRA)
	ldi temp4,BYTE4(SDRA)
	call TEMP1_4_NACH_SECTOR
	call UHR_NULL
;-------------------------------------------------------------------------------
SD_TEST_READ_ALLE_s:
	rcall SD_SECTOR_READ		; read	
	rcall SECTOR_PLUS_EINS		; +1	
	tst SECTOR0
	brne SD_TEST_READ_ALLE_w
	call LCD_ZEILE2
	call SD_PROZENT
	call LCD_ZEILE3
	call LCD_ANZEIGE_SECTOR	
	call LCD_ZEILE4
	call LCD_ANZEIGE_ZEIT
	call TASTATUR_ABFRAGE
	LDS temp,(adr_TASTE)
	tst temp
	brne SD_TEST_READ_ALLE_FERTIG
;-------------------------------------------------------------------------------
SD_TEST_READ_ALLE_w:
	rcall SD_SECTOR_OVERLOW_C
	brcc SD_TEST_READ_ALLE_s
	call LCD_TEXT_FERTIG
	call PROGRAMM_STOP
;-------------------------------------------------------------------------------
SD_TEST_READ_ALLE_FERTIG:

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
SD_TEST_WRITE:
 	call ZUFALLSZAHL			; Kontrollbyte
	call SECTOR_NULL
	call DATA_CLEAR
	call UHR_NULL
;-------------------------------------------------------------------------------
SD_TEST_WRITE_s:
	STS(adr_DATA+0),SECTOR3		; DATA	
	STS(adr_DATA+1),SECTOR2
	STS(adr_DATA+2),SECTOR1
	STS(adr_DATA+3),SECTOR0
	LDS temp,(adr_ZUFALLSZAHL)	; Kontrollbyte
	STS(adr_DATA+4),temp
	call SD_SECTOR_WRITE		; write	
	call SECTOR_PLUS_EINS		; +1	
	LDS temp,(adr_ss)
	tst temp
	breq SD_TEST_WRITE_s
;-------------------------------------------------------------------------------
	call LCD_CLEAR
	call LCD_TEXT_SD
	call LCD_TEXT_WRITE
	call LCD_TEXT_TEST
	call LCD_ZEILE2
	call LCD_ANZEIGE_SECTOR
	call LCD_TEXT_SEC_PRO_SEC
;-------------------------------------------------------------------------------
SD_TEST_WRITE_s1:
	call SECTOR_MINUS_EINS		; -1	
	call SD_SECTOR_READ		; read		
;-------------------------------------------------------------------------------
	LDS temp,(adr_DATA+0)
	cp temp,SECTOR3				; Vegleich	
	brne SD_TEST_WRITE_ERROR
	LDS temp,(adr_DATA+1)
	cp temp,SECTOR2				; Vegleich	
	brne SD_TEST_WRITE_ERROR
	LDS temp,(adr_DATA+2)
	cp temp,SECTOR1				; Vegleich	
	brne SD_TEST_WRITE_ERROR
	LDS temp,(adr_DATA+3)
	cp temp,SECTOR0				; Vegleich	
	brne SD_TEST_WRITE_ERROR

	LDS temp,(adr_DATA+4)
	LDS temp1,(adr_ZUFALLSZAHL)	; Kontrollbyte
	cp temp,temp1				; Vegleich	
	brne SD_TEST_WRITE_ERROR
;-------------------------------------------------------------------------------
	tst SECTOR0
	brne SD_TEST_WRITE_s1
	tst SECTOR1
	brne SD_TEST_WRITE_s1
	tst SECTOR2
	brne SD_TEST_WRITE_s1
	tst SECTOR3
	brne SD_TEST_WRITE_s1
;-------------------------------------------------------------------------------
	call TASTATUR_ABFRAGE
	LDS temp,(adr_TASTE)
	tst temp
	brne SD_TEST_WRITE_ENDE
	call WAIT_1s
	rjmp SD_TEST_WRITE	
SD_TEST_WRITE_ENDE:
ret
;-------------------------------------------------------------------------------
SD_TEST_WRITE_ERROR:
	call LCD_CLEAR
	call LCD_TEXT_ERROR
	call LCD_ZEILE2
	call LCD_ANZEIGE_SECTOR
	call PROGRAMM_STOP
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
SD_FORMATIERUNG_LL:
	call SECTOR_NULL
	call UHR_NULL
SD_FORMATIERUNG_s:
	call DATA_CLEAR
	call SD_SECTOR_WRITE
	tst SECTOR0
	brne SD_FORMATIERUNG_w 
;-------------------------------------------------------------------------------
	call LCD_ZEILE1
	call LCD_TEXT_SD
	call LCD_TEXT_FORMAT
	call LCD_ZEILE2
	call SD_PROZENT
	call LCD_ZEILE3
	call LCD_ANZEIGE_SECTOR	
	call LCD_ZEILE4
	call LCD_ANZEIGE_ZEIT
	call TASTATUR_ABFRAGE
;-------------------------------------------------------------------------------
SD_FORMATIERUNG_w:
	call SECTOR_PLUS_EINS
	rcall SD_SECTOR_OVERLOW_C
	brcc SD_FORMATIERUNG_s	; Schleife	
	call LCD_TEXT_FERTIG
	call PROGRAMM_STOP
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
SD_KOPIE_NACH_IDE:
	call SECTOR_NULL
	call UHR_NULL
;-------------------------------------------------------------------------------
SD_KOPIE_NACH_IDE_s:
	call SD_SECTOR_READ		; read	
	call IDE_SECTOR_WRITE		; WRITE	
	tst SECTOR0
	brne SD_KOPIE_NACH_IDE_w
;-------------------------------------------------------------------------------
	call LCD_ZEILE2
	call LCD_TEXT_IDE
	call IDE_PROZENT
	call LCD_TEXT_SD
	call SD_PROZENT
	call LCD_ZEILE3
	call LCD_ANZEIGE_SECTOR	
	call LCD_ZEILE4
	call LCD_ANZEIGE_ZEIT
	call TASTATUR_ABFRAGE
;-------------------------------------------------------------------------------
SD_KOPIE_NACH_IDE_w:
	call SECTOR_PLUS_EINS
	rcall IDE_SECTOR_OVERLOW_C
	brcs SD_KOPIE_NACH_IDE_FERTIG
	rcall SD_SECTOR_OVERLOW_C
	brcs SD_KOPIE_NACH_IDE_FERTIG
	rjmp SD_KOPIE_NACH_IDE_s
;-------------------------------------------------------------------------------
SD_KOPIE_NACH_IDE_FERTIG:
	call LCD_TEXT_FERTIG
	call PROGRAMM_STOP
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
