; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE:
	call LCD_ZEILE1		; ZEILE1
	LDS temp1,(adr_TASTE)
	tst temp1
	breq MENUE_RUN
	call LCD_CLEAR
;-------------------------------------------------------------------------------
MENUE_p:
	LDS temp1,(adr_TASTE)
	cpi temp1,(TASTE_MENUE_PLUS)
	brne MENUE_m
	LDS temp,(adr_MENUE)
	inc temp
	STS(adr_MENUE),temp
;-------------------------------------------------------------------------------
MENUE_m:
	cpi temp1,(TASTE_MENUE_MINUS)
	brne MENUE_RUN
	LDS temp,(adr_MENUE)
	tst temp
	breq MENUE_RUN
	dec temp
	STS(adr_MENUE),temp
;-------------------------------------------------------------------------------
MENUE_RUN:
	ldi ZL, LOW(MENUE_SPRUNGMARKE)	; Z		
	ldi ZH,HIGH(MENUE_SPRUNGMARKE)
	LDS temp,(adr_MENUE)
	LSL temp	; x2, wegen "jmp (2 Words)"	
	add ZL,temp
	adc ZH,NULL
	IJMP	; SPRUNG nach Z
;-------------------------------------------------------------------------------
MENUE_SPRUNGMARKE:
	jmp MENUE_IDE_SD_INFO
	jmp IDE_INFO
	jmp SD_INFO
	jmp MENUE_IDE_READ_TEST
	jmp MENUE_IDE_READ_TEST_ALLE
	jmp MENUE_IDE_SLEEP
	jmp MENUE_IDE_SEEK_READ
	jmp MENUE_SD_READ_TEST
	jmp MENUE_SD_READ_TEST_ALLE
	jmp MENUE_IDE_STATUS
	jmp MENUE_SD_STATUS
	jmp MENUE_SYSTEM_STATUS
	jmp MENUE_WARNUNG			; Warnung !!
	jmp MENUE_IDE_WRITE_TEST
	jmp MENUE_SD_WRITE_TEST
	jmp MENUE_IDE_FORMATIERUNG_LL
	jmp MENUE_SD_FORMATIERUNG_LL
	jmp MENUE_IDE_KOPIE_NACH_SD	; IDE-->SD	
	jmp MENUE_SD_KOPIE_NACH_IDE	; SD -->IDE	
	jmp LCD_ANZEIGE_BEGRUESSUNG
	jmp MENUE_BAUSTELLE
	jmp MENUE_BAUSTELLE
	jmp MENUE_BAUSTELLE
	jmp MENUE_BAUSTELLE
	jmp MENUE_BAUSTELLE
	jmp MENUE_BAUSTELLE
	STS(adr_MENUE),NULL
	ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_BAUSTELLE:
	call LCD_M
	call LCD_E
	call LCD_N
	call LCD_U
	call LCD_E
	call LCD_DOPPEL_PUNKT_SPACE
	LDS temp1,(adr_MENUE)
	call LCD_ZAHL_TEMP1
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; "wirklich ?"																	
; OUT: Carry																	
MENUE_FRAGE_C:
	call LCD_CLEAR
	call LCD_TEXT_WIRKLICH
;-------------------------------------------------------------------------------
MENUE_FRAGE_s:
	call TASTATUR_ABFRAGE
	LDS temp,(adr_TASTE)
	tst temp
	brne MENUE_FRAGE_s
;-------------------------------------------------------------------------------
	call LCD_ZEILE3			; ZEILE
	call LCD_TEXT_TASTE
	call LCD_GAENSEFUESSCHEN
	call LCD_MINUS
	call LCD_GAENSEFUESSCHEN
	call LCD_SPACE
	call LCD_ISTGLEICH
	call LCD_O
	call LCD_K
	call WAIT_100ms
;-------------------------------------------------------------------------------
MENUE_FRAGE_s1:
	call TASTATUR_ABFRAGE
	call TASTE_MINUS_C	; Taste '-' = Ja	
	brcs MENUE_FRAGE_JA
	LDS temp,(adr_TASTE)
	tst temp
	breq MENUE_FRAGE_s1
;-------------------------------------------------------------------------------
MENUE_FRAGE_NEIN:
	call LCD_CLEAR
	call LCD_TEXT_ABBRUCH
	call WAIT_1s
	CLC ;Clear Carry
	ret
MENUE_FRAGE_JA:
	call LCD_CLEAR
	SEC ;Set Carry	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_IDE_SD_INFO:
	call LCD_CLEAR
	call LCD_TEXT_IDE
	call LCD_SPACE
	LDS temp1,(adr_IDE_CAPACITY_MB0)
	LDS temp2,(adr_IDE_CAPACITY_MB1)
	LDS temp3,(adr_IDE_CAPACITY_MB2)
	LDS temp4,(adr_IDE_CAPACITY_MB3)
	call LCD_ZAHL_TEMP1_2_3_4
	call LCD_M
	call LCD_B

	; ZEILE2	
	call LCD_ZEILE2
	; ZEILE3		
	call LCD_ZEILE3
	call LCD_TEXT_SD
	call LCD_SPACE2
	LDS temp1,(adr_SD_CAPACITY_MB0)
	LDS temp2,(adr_SD_CAPACITY_MB1)
	LDS temp3,(adr_SD_CAPACITY_MB2)
	LDS temp4,(adr_SD_CAPACITY_MB3)
	call LCD_ZAHL_TEMP1_2_3_4
	call LCD_M
	call LCD_B

	; ZEILE4		
	call LCD_ZEILE4
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_IDE_READ_TEST:
	call LCD_TEXT_IDE
	call LCD_TEXT_READ
	call LCD_TEXT_TEST
	call TASTE_PLUS_C		; TASTE '+'	
	brcs MENUE_IDE_SPEED_TEST_RUN
	ret
;-------------------------------------------------------------------------------
MENUE_IDE_SPEED_TEST_RUN:
	call IDE_TEST_READ
	call LCD_ANZEIGE_OK
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_IDE_READ_TEST_ALLE:
	call LCD_TEXT_IDE
	call LCD_TEXT_READ
	call LCD_TEXT_ALLE
	call TASTE_PLUS_C		; TASTE '+'	
	brcs MENUE_IDE_READ_TEST_ALLE_RUN
	ret
;-------------------------------------------------------------------------------
MENUE_IDE_READ_TEST_ALLE_RUN:
	call IDE_TEST_READ_ALLE
	call LCD_ANZEIGE_OK
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_IDE_SLEEP:
	call LCD_TEXT_IDE
	call LCD_TEXT_SLEEP
	call TASTE_PLUS_C		; TASTE '+'	
	brcs MENUE_IDE_SLEEP_RUN
	ret
;-------------------------------------------------------------------------------
MENUE_IDE_SLEEP_RUN:
	call IDE_SLEEP
	call LCD_ANZEIGE_OK
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_IDE_SEEK_READ:
	call LCD_TEXT_IDE
	call LCD_TEXT_SEEK
	call LCD_TEXT_READ
	call TASTE_PLUS_C		; TASTE '+'	
	brcs MENUE_IDE_SEEK_READ_RUN
	ret
;-------------------------------------------------------------------------------
MENUE_IDE_SEEK_READ_RUN:
	call IDE_TEST_SEEK_READ
	call LCD_ANZEIGE_OK
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_SD_READ_TEST:
	call LCD_TEXT_SD
	call LCD_TEXT_READ
	call LCD_TEXT_TEST
	call TASTE_PLUS_C		; TASTE '+'	
	brcs MENUE_SD_SPEED_TEST_RUN
	ret
;-------------------------------------------------------------------------------
MENUE_SD_SPEED_TEST_RUN:
	call SD_TEST_READ
	call LCD_ANZEIGE_OK
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_SD_READ_TEST_ALLE:
	call LCD_TEXT_SD
	call LCD_TEXT_READ
	call LCD_TEXT_ALLE
	call TASTE_PLUS_C		; TASTE '+'	
	brcs MENUE_SD_READ_TEST_ALLE_RUN
	ret
;-------------------------------------------------------------------------------
MENUE_SD_READ_TEST_ALLE_RUN:
	call SD_TEST_READ_ALLE
	call LCD_ANZEIGE_OK
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_IDE_STATUS:
	call LCD_ZEILE1
	call LCD_TEXT_IDE
	call LCD_TEXT_STATUS
	call IDE_WAIT_BUSHY
	LDS temp1,(adr_IDE_REGISTER_STATUS)
	call LCD_HEX_TEMP1


	call LCD_ZEILE2
	call LCD_ANZEIGE_IDE_REGISTER_STATUS

	call LCD_ZEILE3
	call LCD_TEXT_ERROR
	LDS temp1,(adr_IDE_REGISTER_ERROR)
	call LCD_HEX_TEMP1
	call LCD_SCHRAEGSTRICH
	LDS temp1,(adr_IDE_REGISTER_ERROR_LAST)
	call LCD_HEX_TEMP1

	call LCD_ZEILE4
	call LCD_ANZEIGE_IDE_REGISTER_ERROR
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_SD_STATUS:
	call LCD_ZEILE1
	call LCD_TEXT_SD
	call LCD_TEXT_STATUS
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_SYSTEM_STATUS:
	call LCD_ZEILE1
	call LCD_TEXT_SYSTEM
	call LCD_TEXT_STATUS


	call LCD_ZEILE2
	call LCD_TEXT_TASTE
	call LCD_DOPPEL_PUNKT_SPACE
	LDS temp1,(adr_TASTE)
	call LCD_ZAHL_TEMP1

	call LCD_ZEILE3
	call LCD_D
	call LCD_0
	call LCD_DOPPEL_PUNKT
	in temp1,(IDE_DATA0_PIN)
	call LCD_HEX_TEMP1

	call LCD_ZEILE4
	call LCD_D
	call LCD_1
	call LCD_DOPPEL_PUNKT
	in temp1,(IDE_DATA1_PIN)
	call LCD_HEX_TEMP1

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_WARNUNG:
	call LCD_TEXT_WARNUNG
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_IDE_WRITE_TEST:
	call LCD_TEXT_IDE
	call LCD_TEXT_WRITE
	call LCD_TEXT_TEST	
	call TASTE_PLUS_C		; TASTE '+'	
	brcs MENUE_IDE_WRITE_TEST_RUN
	ret
;-------------------------------------------------------------------------------
MENUE_IDE_WRITE_TEST_RUN:
	call MENUE_FRAGE_C		; wirklich ?
	brcs MENUE_IDE_WRITE_TEST_ACTION
	ret
;-------------------------------------------------------------------------------
MENUE_IDE_WRITE_TEST_ACTION:
	call IDE_TEST_WRITE
	call LCD_ANZEIGE_OK
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_SD_WRITE_TEST:
	call LCD_TEXT_SD
	call LCD_TEXT_WRITE
	call LCD_TEXT_TEST
	call TASTE_PLUS_C		; TASTE '+'	
	brcs MENUE_SD_WRITE_TEST_RUN
	ret
;-------------------------------------------------------------------------------
MENUE_SD_WRITE_TEST_RUN:
	call MENUE_FRAGE_C		; wirklich ?
	brcs MENUE_SD_WRITE_TEST_ACTION
	ret
;-------------------------------------------------------------------------------
MENUE_SD_WRITE_TEST_ACTION:
	call SD_TEST_WRITE
	call LCD_ANZEIGE_OK
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_IDE_FORMATIERUNG_LL:
	call LCD_TEXT_IDE
	call LCD_TEXT_FORMAT
	call TASTE_PLUS_C		; TASTE '+'	
	brcs MENUE_IDE_FORMATIERUNG_LL_RUN
	ret
;-------------------------------------------------------------------------------
MENUE_IDE_FORMATIERUNG_LL_RUN:
	call MENUE_FRAGE_C		; wirklich ?
	brcs MENUE_IDE_FORMATIERUNG_LL_ACTION
	ret
;-------------------------------------------------------------------------------
MENUE_IDE_FORMATIERUNG_LL_ACTION:
	call IDE_FORMATIERUNG_LL
	call LCD_ANZEIGE_OK
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_SD_FORMATIERUNG_LL:
	call LCD_TEXT_SD
	call LCD_TEXT_FORMAT
	call TASTE_PLUS_C		; TASTE '+'	
	brcs MENUE_SD_FORMATIERUNG_LL_RUN
	ret
;-------------------------------------------------------------------------------
MENUE_SD_FORMATIERUNG_LL_RUN:
	call MENUE_FRAGE_C		; wirklich ?
	brcs MENUE_SD_FORMATIERUNG_LL_ACTION
	ret
;-------------------------------------------------------------------------------
MENUE_SD_FORMATIERUNG_LL_ACTION:
	call SD_FORMATIERUNG_LL
	call LCD_ANZEIGE_OK
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_IDE_KOPIE_NACH_SD:
	call LCD_TEXT_IDE
	call LCD_TEXT_KOPIE_NACH
	call LCD_TEXT_SD
	call TASTE_PLUS_C		; TASTE '+'	
	brcs MENUE_IDE_KOPIE_NACH_SD_RUN
	ret
;-------------------------------------------------------------------------------
MENUE_IDE_KOPIE_NACH_SD_RUN:
	call MENUE_FRAGE_C		; wirklich ?
	brcs MENUE_IDE_KOPIE_NACH_SD_ACTION
	ret
;-------------------------------------------------------------------------------
MENUE_IDE_KOPIE_NACH_SD_ACTION:
	call LCD_CLEAR
	call LCD_TEXT_IDE
	call LCD_TEXT_KOPIE_NACH
	call LCD_TEXT_SD
	call IDE_KOPIE_NACH_SD
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_SD_KOPIE_NACH_IDE:
	call LCD_TEXT_SD
	call LCD_TEXT_KOPIE_NACH
	call LCD_TEXT_IDE
	call TASTE_PLUS_C		; TASTE '+'	
	brcs MENUE_SD_KOPIE_NACH_IDE_RUN
	ret
;-------------------------------------------------------------------------------
MENUE_SD_KOPIE_NACH_IDE_RUN:
	call MENUE_FRAGE_C		; wirklich ?
	brcs MENUE_SD_KOPIE_NACH_IDE_ACTION
	ret
;-------------------------------------------------------------------------------
MENUE_SD_KOPIE_NACH_IDE_ACTION:
	call LCD_CLEAR
	call LCD_TEXT_SD
	call LCD_TEXT_KOPIE_NACH
	call LCD_TEXT_IDE
	call SD_KOPIE_NACH_IDE
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################

